stages:
  - Static Analysis
  - test
  - Release

.go-cache:
    variables:
        GOPATH: $CI_PROJECT_DIR/.go
    cache:
      paths:
        - .go/pkg/mod/

lint:
    image: golangci/golangci-lint:v1.55.0
    stage: Static Analysis
    allow_failure: false
    extends: .go-cache
    script:
      - golangci-lint run -v --go=1.21 --tests=false | tee lint.txt
    artifacts:
      when: on_failure
      paths:
        - lint.txt

go-test:
  stage: test
  image: golang:1.21
  extends: .go-cache
  services:
    - docker:dind
  variables:
    DOCKER_HOST: tcp://docker:2375
    DOCKER_DRIVER: overlay2
    YOUR_APP_DB_HOST: docker
  script:
    - go test -v ./... | tee test.txt
  artifacts:
      when: on_failure
      paths:
        - test.txt

release-image:
  stage: Release
  image: docker:24.0.2
  services:
    - docker:dind
  before_script:
    - docker login -u "$CI_REGISTRY_USER" -p "$CI_REGISTRY_PASSWORD" $CI_REGISTRY
  script:
    - docker build --cache-from "$CI_REGISTRY_IMAGE/$CI_COMMIT_BRANCH:latest" -t "$CI_REGISTRY_IMAGE/$CI_COMMIT_BRANCH:latest" -t "$CI_REGISTRY_IMAGE/$CI_COMMIT_BRANCH:$CI_COMMIT_SHA" .
    - docker push "$CI_REGISTRY_IMAGE/$CI_COMMIT_BRANCH" --all-tags